import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Button here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Button  extends Actor
{
    //WAVE DATA
    private double sway=0,svel = -.4;
    private double mag = 11;
    private double alpha = 0;
    
    //BUTTON TYPE DATA
    private int type;
    
    //MOUSE DATA
    private int mx,my;
    private int fidelity=1;
    
    //IMAGE DATA
    private static GreenfootImage button1 = new GreenfootImage("Button1.png");
    private static GreenfootImage button2 = new GreenfootImage("Button2.png");
    private static GreenfootImage button3 = new GreenfootImage("Button3.png");
    private static GreenfootImage buffer = new GreenfootImage(500,2);
    private GreenfootImage button;
    private GreenfootImage image;
    
    //BUTTON****************************************************************************
    //  sets the type of button and the sway fidelity
    
    public Button(int t){
        type = t;
        if(type==1){
            button = button1;
        }
        if(type==2){
            button = button2;
        }
        if(type==3){
            button = button3;
        }
        image = new GreenfootImage(button.getWidth()+10,button.getHeight());
        setImage(image);
        if(image.getHeight()>70){
            fidelity = 2;
        }
    }
    
    //ACT****************************************************************************
    //  takes care of the wave effect and mouse highlighting
    
    public void act() 
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(mouse!=null){
            mx = mouse.getX();
            my = mouse.getY();
        }
        image.setTransparency((int)alpha);
        if(mx>getX()-image.getWidth()/2 && mx<getX()+image.getWidth()/2 && my<getY()+image.getHeight()/2 && my>getY()-image.getHeight()/2){
            svel += (.2-svel)/13;
            mag += (3-mag)/13;
            alpha += (255-alpha)/16;
            if(Greenfoot.mousePressed(null)){
                activate();
                mag = 4;
                svel = .4;
            }
        }else{
            svel += (.14-svel)/20;
            mag += (1.2-mag)/20;
            alpha += (120-alpha)/29;
        }
        
        
        image.clear();
        for(int i=0;i<button.getHeight();i += fidelity){
            buffer.clear();
            buffer.drawImage(button,0,-i);
            image.drawImage(buffer,(int)(mag*Math.sin(sway+i/2)),i);
            //getWorld().repaint();
        }
        sway += svel;
    }   
    
    //ACTIVATE****************************************************************************
    //  activates when the button is clicked
    
    public void activate(){
        if(type==1 && getWorld().getObjects(codes.class).size()==0){
            ((worldness)getWorld()).quitMenu();
        }
        if(type==2 && getWorld().getObjects(codes.class).size()==0){
            getWorld().addObject(new codes(),0,0);
        }
        if(type==3){
            ((worldness)getWorld()).reloadMenu();
        }
    }
    
    //RESET****************************************************************************
    //  sets the button back to no alpha
    
    public void reset(){
        alpha = 0;
        image.setTransparency((int)alpha);
        mx = 999;
    }
}
