import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;

public class Cup  extends BouncerActor
{
    private int filled = 0;
    private int counter=0;
    private Color color;
    private int full=0;
    private boolean frozen = false;

    public Cup(){
        setSelectable(false);
        color = Color.blue;
    }
    
    public Cup(Color c){
        setSelectable(false);
        color = c;
    }
    
    public Cup(Color c,int ang){
        setSelectable(false);
        color = c;
        setRotation(ang);
    }
    
    protected void addedToWorld(World world){
        super.addedToWorld(world);
        recolor(color);
    }
    
    public void act() 
    {
        if(Greenfoot.isKeyDown("1")){
            frozen = true;
            full = 1;
        }
        if(frozen)
            return;
        super.act();
        getImage().setColor(Color.white);
        getImage().fillRect(3,16,23,5);
        getImage().setColor(color);
        getImage().fillRect(3,16,filled,5);
        counter--;
        if(counter<0 && filled>0 && counter%10==0){
            filled--;
        }
        full=0;
        if(filled==23){
            full=1;
        }
    }  
    
    public boolean special(drop b){
        getWorld().removeObject(b);
        if(b.getColor().equals(color)){
            if(filled!=23)
                filled++;    
            counter=40;
        }   
        return false;
    }
    
    public void freeze(){
        frozen = true;
    }
    
    public int isFull(){
        return full;
    }
}
