import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class Display  extends Actor
{
    //DISPLAY DATA
    private static GreenfootImage numbers = new GreenfootImage("Numbers.bmp");
    private static GreenfootImage buffer = new GreenfootImage(19,30);
    private GreenfootImage image;
    
    //NUMBER DATA
    private int num;
    private int digits;
    private int counter=0;
    
    //DESIRE DATA
    private int desired=0;
    private int delta = 163840;
    
    //DISPLAY***************************************************************************
    //  basic constructor for the object
    
    public Display(int n,int d){
        digits = d;
        num = n;
        image = new GreenfootImage(19*digits,40);
        for(int i=0;i<numbers.getWidth();i++){
            for(int j=0;j<numbers.getHeight();j++){
                if(numbers.getColorAt(i,j).equals(Color.white)){
                    numbers.setColorAt(i,j,new Color(0,0,0,0));
                }
            }
        }  
        setImage(image);
    }
    
    //ACT****************************************************************************
    //  draws the number onto the screen, also moves number towards the 'desired' number
    
    public void act() 
    {
        counter++;
        image.clear();
        for(int i=digits-1;i>=0;i--){
            buffer.clear();
            buffer.drawImage(numbers,-19*getDigit(num,i),0);
            image.drawImage(buffer,19*digits - 19*i - 19,0);
        }  
        if(desired!=0){
            while(Math.abs(num-desired)<delta){
                delta = delta/8;
            }
            if(counter%3 == 0){
                Greenfoot.playSound("Down.wav");
            }
            
            if(num>desired){
                num -= delta;
            }
            if(num<desired){
                num += delta;
            }
            if(num==desired){
                desired = 0;
            }
        }
            
    } 
    
    //GETDIGIT****************************************************************************
    //  returns a specific digit of any number
    
    public int getDigit(int n,int d){
        double decimal = n;
        decimal = (int)(decimal/Math.pow(10,d));
        n = (int)(.5 + 10*(decimal/10 - (int)(decimal/10)));
        return n;
    }
    
    //SETDATA****************************************************************************
    //  sets the number and number of digits
    
    public void setData(int n,int d){
        num = n;
        digits = d;
    }
    
    //GETNUM****************************************************************************
    //  returns the number that this object displays
    
    public int getNum(){
        return num;
    }
    
    //SETNUM****************************************************************************
    //  sets the number of this display
    
    public void setNum(int n){
        num = n;
    }
    
    //SETDESIREDNUMBER****************************************************************************
    //  sets the number that this display will try to get to
    
    public void setDesiredNumber(int d){
        desired = d;
        delta = 81920;
    }
}
