import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Door here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Door  extends BouncerActor
{
    private Color color = Color.black;
    private int dir = 4;
    private int open = 1;
    private int counter=0;
    private int length;
    private int speed=8;
    private boolean frozen = false;
    
    public Door(int l,int ang,Color c){
        setImage(new GreenfootImage(5,l));
        setRotation(ang);
        color = c;
        length = l;
    }
    
    public Door(int l,int ang){
        setImage(new GreenfootImage(5,l));
        setRotation(ang);
        color = Color.blue;
        length = l;
    }
    
    protected void addedToWorld(World world){
        getImage().setColor(Color.black);
        getImage().fill();
        setSelectable(false);
        super.addedToWorld(world);
        getImage().setColor(color);
        getImage().fill();
    }
    
    
    
    public void act() 
    {
        if(frozen)
            return;
        super.act();
        getImage().fill();
        if((dir>0 || open==1) && dir!=speed+1){
            if(dir==1 && open ==1){
                Greenfoot.playSound("open.wav");
            }
            if(dir==speed && open == -1){
                Greenfoot.playSound("close.wav");
            }
            setActivity(true);
            getImage().clear();
            getImage().fillRect(0,0,5,(int)((dir/((double)speed))*length/2));
            getImage().fillRect(0,length/2+(int)((1-dir/((double)speed))*length/2),5,length);
            dir += open;
        }
        if(dir==0){
            setActivity(false);
            getImage().clear();
            getImage().fillRect(0,0,5,0);
            getImage().fillRect(0,length-1,5,1);
        }
        open = 1;
        counter++;
            
    }    
    
    
    public void open(){
        open = -1;
        if(dir>speed)
            dir = speed;
    }

    
    public Color getColor(){
        return color;
    }
    
    public void freeze(){
        frozen = true;
    }
}
