import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;


public class Pipe  extends BouncerActor
{
    //OBJECT DATA
    private int counter=0;
    private boolean frozen = false;
    private boolean erasing = false;
    private GreenfootImage dropImage = new GreenfootImage("drop.bmp");
    private Color color;
    
    //PIPE****************************************************************************
    //  sets the Pipes color to default blue
    
    public Pipe(){
        color = Color.blue;
        setSelectable(false);
    }
    
    //PIPE****************************************************************************
    //  sets the pipe color
    
    public Pipe(Color c){
        color = c;
        setSelectable(false);
    }
    
    //ADDEDTOWORLD****************************************************************************
    //  creates the drop image and adds to world
    
    protected void addedToWorld(World world){
        super.addedToWorld(world);
        dropImage.setColor(color);
        for(int i=0;i<9;i++){
            for(int j=0;j<9;j++){
                if(dropImage.getColorAt(i,j).equals(Color.white)){
                    dropImage.setColorAt(i,j,new Color(0,0,0,0));
                }
            }
        }
        dropImage = worldness.recolor(dropImage,color);
        setImage(worldness.recolor(getImage(),color));
    }
    
    //ACT****************************************************************************
    //  adds drops to the world
    
    public void act() 
    {
        
        
        if(frozen)
            return;
            
        if(erasing){
            List drops = getWorld().getObjects(drop.class);
            int max = 0;
            drop nextDrop = null;
            boolean allDone = true;
            
            for(int i=0;i<drops.size();i++){
                drop d = (drop)drops.get(i);
                if(d.getColor().equals(color) && d.getLife()>max){
                    nextDrop = d;
                    max = d.getLife();
                    allDone = false;
                }
            }
            if(allDone){
                erasing = false;
            }else{
                getWorld().removeObject(nextDrop);
            }
            //return;
        }
            
        if(Greenfoot.mouseClicked(this)){
            erasing = true;
        }
        
            
            
        super.act();
        counter++;
        if(counter%8==0){
            getWorld().addObject(new drop(dropImage,color),getX(),getY()+13);
        }
    }    
    
    //FREEZE****************************************************************************
    //  freeezes the output
    
    public void freeze(){
        frozen = true;
        erasing = false;
    }
}
