import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;

public class Switch  extends BouncerActor
{
    //IMAGE DATA
    private GreenfootImage switchUp;
    private GreenfootImage switchDown;
    
    //OBJECT DATA
    private Color color;
    private int down = 0;
    private List doors;
    
    //SWITCH****************************************************************************
    //  sets the swithces color and angle
    
    public Switch(Color c,int ang){
        color = c;
        setRotation(ang);
    }
    
    //SWITCH****************************************************************************
    //  sets the switches color, angle, and elasticity
    
    public Switch(Color c,int ang,double e){
        color = c;
        setRotation(ang);
        setElasticity(e);
    }
    
    //SWITCH****************************************************************************
    //  sets the color to default blue and a specific angle
    
    public Switch(int ang){
        color = Color.blue;
        setRotation(ang);
    }
    
    //ADDEDTOWORLD****************************************************************************
    //  creats the switch images and adds to the world
    
    protected void addedToWorld(World world){
        setSelectable(false);
        super.addedToWorld(world);
        recolor(color);
        switchUp = new GreenfootImage(getImage());
        switchDown = new GreenfootImage(getImage());
        switchUp.setColor(Color.black);
        switchUp.fillRect(8,7,14,2);
    }
    
    //ACT****************************************************************************
    //  moves the door to the desired position
    
    public void act() 
    {
        down--;
        if(down>0){
            setImage(switchDown);
            for(int i=0;i<doors.size();i++){
                Door d = (Door)doors.get(i);
                if(d.getColor().equals(color)){
                    d.open();
                    
                }
            }
        }else{
            setImage(switchUp);
        }
        super.act();
    }    
    
    //SPECIAL****************************************************************************
    //  called when an object hits the button
    
    public boolean special(drop a){
        doors = getWorld().getObjects(Door.class);
        down = 20;
        return true;
    }
    
    
}
