import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


public class drop extends Actor
{
    //BALL DATA
    private double x=0,y=0,a=0,b=0,ang,angN,mag,angx,angy,magG;
    private double elasticity;
    private int life = 0;
    private Color color;
    
    //HELPER DATA
    private int numAng=0;
    private int counter;
    private int counts;
    
    //BOOLEAN DATA
    private boolean isObject=false;
    private boolean print = false;
    private boolean special = false;
    private boolean frozen = false;
    
    //CONSTRUCTORS*****************************************************************************
    //  constructs the ball and gives it its color
    
    public drop(GreenfootImage i,Color c){
        setImage(i);
        color = c;
    }
    
    public drop(GreenfootImage i,Color c,double xa,double ya){
        setImage(i);
        color = c;
        a = xa;
        b = ya;
    }
    
    public drop(){
    }

    //ADDEDTOWORLD*****************************************************************************
    //  adds ball to world/sets coordinates
    
    protected void addedToWorld(World world){
        x=getX();
        y=getY();
        if(x>490 || x<10 || y>490 || y<10){
            getWorld().removeObject(this);
            return;
        }
    }
    
    //ACT*****************************************************************************
    //  Main act method inclusing colission and physics
        
    public void act() 
    {
        life++;
        if(frozen)
            return;
        
        if(Greenfoot.isKeyDown("p"))
            print = true;
        counts = 0;
        while(!((worldness)getWorld()).okObject((int)x,(int)y) && counts<50){
            y -= b/10;
            x -= a/10;
            counts++;
        }  
        if(counts>49){
            getWorld().removeObject(this);
            return;
        }
        
        numAng=0;
        angx=0;
        angy=0;
        isObject = false;
        special = false;
        int temp=0;
        while(temp<7 && numAng<2){
            x += a/7;
            y += b/7;
            if(y>490 || x<10 || x>490 || y<10){
                getWorld().removeObject(this);
                return;
            }
            temp++;
            numAng=0;
            for(int f=0;f<360;f=f+40){
                special = special || special((int)x,(int)y);
                if(!ok((int)(x+3*Math.cos((f/180.0)*Math.PI)),(int)(y+3*Math.sin((f/180.0)*Math.PI)))){
                    numAng++;
                    angx=angx+Math.cos((f/180.0)*Math.PI);
                    angy=angy+Math.sin((f/180.0)*Math.PI);
                }
            }
        }
        
        if(y>490 || x<10 || x>490 || y<10){
            getWorld().removeObject(this);
            return;
        }

        if(numAng>1 && getWorld()!=null){
            
            setLocation((int)(x+2*a),(int)(y+2*a));  
            BouncerActor bx = (BouncerActor)getOneIntersectingObject(BouncerActor.class);
                
            numAng = 0;
            counts=0;
            while(numAng==0 && !Greenfoot.isKeyDown("c") && counts<50){
                numAng=0;
                x += .1*a;
                y += .1*b;
                angx=0;
                angy=0;
                for(int f=0;f<360;f=f+10){
                    if(!ok((int)(x+7*Math.cos((f/180.0)*Math.PI)),(int)(y+7*Math.sin((f/180.0)*Math.PI))) || !ok((int)(x+4*Math.cos((f/180.0)*Math.PI)),(int)(y+4*Math.sin((f/180.0)*Math.PI)))){
                        numAng++;
                        angx += Math.cos((f/180.0)*Math.PI);
                        angy += Math.sin((f/180.0)*Math.PI);
                    }
                }
                counts++;
            }
            if(counts>49){
                getWorld().removeObject(this);
                return;
            }
            
            counts = 0;
            while(numAng!=0 && !Greenfoot.isKeyDown("c") && counts<40){
                numAng=0;
                x -= .1*angx;
                y -= .1*angy;
                for(int f=0;f<360;f=f+11){
                    if(!ok((int)(x+3*Math.cos((f/180.0)*Math.PI)),(int)(y+3*Math.sin((f/180.0)*Math.PI)))){
                        numAng++;
                    }
                }
                counts++;
            }
            if(counts > 39){
                getWorld().removeObject(this);
                return;
            }
                  
            angN = Math.PI/2.0 + Math.atan2(angy,angx);
            
            if(bx!=null && isObject){
                double offAng =   180*angN/Math.PI - bx.getRealRotation();
                offAng = 90*((int)((offAng+45)/90));
                offAng = Math.PI*(bx.getRealRotation()+offAng)/180;
                
                if(Math.abs(offAng-angN)<.4){
                    angN = offAng;
                }
            }
            
            elasticity = .5;
            
            if(isObject && bx==null){
                double temp1=-3;
                while(temp1<20 && bx==null){
                    if(getWorld()==null)
                        return;
                    setLocation((int)(x+a*temp1),(int)(y+b*temp1));
                    bx = (BouncerActor)getOneIntersectingObject(BouncerActor.class);
                    temp1++;
                }
                if(temp1>19){
                    return;
                }
            }
            if(bx!=null && isObject){
                if(special){
                    if(!bx.special(this)){
                        return;
                    }
                }
                if(!bx.activate(this)){
                    return;
                }  
                elasticity = bx.getElasticity(this);
            }
            
            mag = Math.sqrt(a*a + b*b);
            
            ang = Math.atan2(b,a);
            ang = -(ang-angN)+angN;
            double in = mag*Math.cos((angN-Math.PI/2) - ang);
            double out = mag*Math.sin((angN-Math.PI/2) - ang);
            in *= elasticity;
            a = in*Math.cos(angN-Math.PI/2) + out*Math.sin(angN-Math.PI/2);
            b = in*Math.sin(angN-Math.PI/2) - out*Math.cos(angN-Math.PI/2); 
            
            magG = Math.sin(angN);
            if(angN>Math.PI/2.0 && angN<3*Math.PI/2.0){
                a = a + magG*Math.cos(angN);
                b = b + magG*Math.sin(angN);
            }
            if(Math.abs(a)<.01 && Math.abs(b)<.9){
                a = .1;
            }

        }else {
            if(a*a + (b+.1)*(b+.1) < 64)b=b+.1;
        }

        setLocation((int)x,(int)y); 
        setRotation((int)(180*Math.atan2(b,a)/Math.PI)-90);
        
    }  
    
    //OK*****************************************************************************
    //  collision helper methods
    
    public boolean ok(int X,int Y){
        if(X<0 || X>499 || Y<0 || Y>499 || getWorld()==null){
            if(getWorld()!=null)
                getWorld().removeObject(this);
            return true;
        }
        isObject = isObject || !((worldness)getWorld()).okObject(X,Y);
        return ((worldness)getWorld()).ok(X,Y);
    }
    
    //SPECIAL*****************************************************************************
    //  determines whether or not collision is 'special'
    
    public boolean special(int X,int Y){
        if(X<0 || X>499 || Y<0 || Y>499 || getWorld()==null){
            if(getWorld()!=null)
                getWorld().removeObject(this);
            return true;
        }
        return ((worldness)getWorld()).objectSpecial(X,Y);
    }
    
    //FREEZE*****************************************************************************
    //  freezes the ball for transitions
    
    public void freeze(){
        frozen = true;
    }
    
    //FIX*****************************************************************************
    //  fixes the ball in certain collision circumstances
    
    public void fix(){
        a *= .7;
        b *= .7;
        counts=0;
        while(numAng!=0 && !Greenfoot.isKeyDown("c") && counts<40){
            numAng=0;
            x -= .1*a;
            y -= .1*b;
            for(int f=0;f<360;f=f+10){
                if(!ok((int)(x+4*Math.cos((f/180.0)*Math.PI)),(int)(y+4*Math.sin((f/180.0)*Math.PI))) || !ok((int)(x+4*Math.cos((f/180.0)*Math.PI)),(int)(y+4*Math.sin((f/180.0)*Math.PI)))){
                    numAng++;
                }
            }
            counts++;
        }
        if(counter>40){
            getWorld().removeObject(this);
        }
        
    }
    
    public int getCounter(){
        return counter;
    }
    
    public void setCounter(int n){
        counter = n;
    }
    
    public void setVelocity(double vela,double velb){
        a = vela;
        b = velb;
    }
    
    public boolean isSpecial(){
        return special;
    }
    
    public int getLife(){
        return life;
    }
    
    public Color getColor(){
        return color;
    }
    
    
    
}
