import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;

public class overlay  extends Actor
{
    //TRANSITION DATA
    private int transition=0;
    private boolean transitioning = false;
    private boolean finished = true;
    private boolean killAll = true;
    private boolean sliding = false;
    private int backgroundNum=1;
    
    //LEVEL DATA
    private int level = 0;
    private int currentLevel = 0;
    String[] codes = {"","start","learning","quad","springs","cones","sewage","tricky","hoops","backtrack","cannon","assist","tubes"};
    String currentCode = "";
    
    //OBJECT DATA
    private miniMenu menu = new miniMenu();
    private List bouncers;
    private List drops;
    boolean bonusSound = true;

    //IMAGE DATA
    GreenfootImage background1 = new GreenfootImage("background.bmp");
    GreenfootImage background = new GreenfootImage(500,500);
    GreenfootImage buffer = new GreenfootImage(500,500);
    
    //OVERLAY****************************************************************************
    //  creates the object and sets the image

    public overlay(GreenfootImage image){
        setImage(image);
    }
    
    //ACT****************************************************************************
    //  transitions if neccesary and draws the level code onto the image
    
    public void act() 
    {  
        if(transitioning){
            transition();
            return;
        }
        
        currentCode = codes[level];
        getImage().setColor(Color.white);
        getImage().drawString(currentCode,11,490);
        getImage().drawString(currentCode,12,490);
        getImage().drawString(currentCode,9,490);
        getImage().drawString(currentCode,10,491);
        getImage().drawString(currentCode,10,489);
        getImage().setColor(Color.black);
        getImage().drawString(currentCode,10,490);   
        getImage().drawString(currentCode,11,490); 
    }    
    
    //TRANSITION****************************************************************************
    //  step the transition up one frame
    
    public void transition(){
        ((worldness)getWorld()).setSelection(false);
        if(sliding){
            if(transition == 500){
                loadLevel(level);
                currentLevel = level;
                return;
            }
            if(currentLevel==0 || level==0){
                menu.setScore(0);
            }else{
                menu.setScore(menu.getScore()+1500+menu.getBonus());
            }
            menu.setBonus(0);
            getWorld().getBackground().drawImage(buffer,-transition,0);
            transition+=20;
            getImage().drawImage(background,-transition+500,0);
            for(int i=0;i<bouncers.size();i++){
                ((BouncerActor)bouncers.get(i)).move(-20,0);
            }
            if(getWorld().getObjects(Text.class).size()!=0)
            ((Text)getWorld().getObjects(Text.class).get(0)).move(-20,0);
            
        }else{
            for(int i=0;i<drops.size();i++){
                ((drop)drops.get(i)).getImage().setTransparency(transition);
            }
            getImage().setColor(new Color(255,180,0));
            boolean playSound = false;
            for(int i=0;i<bouncers.size();i++){
                BouncerActor bouncerA = ((BouncerActor)bouncers.get(i));
                if(bouncerA.isAway()){
                    playSound = true;
                    menu.setBonus(menu.getBonus()+100);
                    getImage().drawOval((int)(bouncerA.getX()-40*Math.cos(transition/255.0)),(int)(bouncerA.getY()-40*Math.cos(transition/255.0)),(int)(80*Math.cos(transition/255.0)),(int)(80*Math.cos(transition/255.0)));
                    getImage().drawOval((int)(bouncerA.getX()-38*Math.cos(transition/255.0)),(int)(bouncerA.getY()-38*Math.cos(transition/255.0)),(int)(76*Math.cos(transition/255.0)),(int)(76*Math.cos(transition/255.0)));
                    getImage().drawOval((int)(bouncerA.getX()-36*Math.cos(transition/255.0)),(int)(bouncerA.getY()-36*Math.cos(transition/255.0)),(int)(72*Math.cos(transition/255.0)),(int)(72*Math.cos(transition/255.0)));
                }
            }
            if(playSound && transition%20==0){
                Greenfoot.playSound("Roto.wav");
            }
            transition -= 10;
            if(transition==-10){
                transition = 0;
                sliding = true;
            }
        }
    }
    
    //START****************************************************************************
    //  starts the transition off and sets the next level
    
    public void start(){
        if(currentLevel==12){
            String[] message = {"You beat all the levels and cleaned all the water!  Congratulations!",
                                "Your final score was: "+menu.getScore()+" !"};
            getWorld().addObject(new Text(message),20,20);
            ((worldness)getWorld()).fireworks();
            killAll = true;
            level = 0;
        }
        ((worldness)getWorld()).setSelection(false);
        transitioning = true;
        background = worldness.recolor(new GreenfootImage(background1),new Color(Greenfoot.getRandomNumber(200)+55,Greenfoot.getRandomNumber(200)+55,Greenfoot.getRandomNumber(200)+55));
        if(currentLevel==0 || level==0){
            sliding = true;
            transition = 0; 
            ((worldness)getWorld()).setInMenu(false);
            background.drawImage(new GreenfootImage("MiniMenu.bmp"),0,0);
            getWorld().setPaintOrder(overlay.class,Display.class,Button.class,miniMenu.class,BouncerActor.class,drop.class);
        }else{
            Greenfoot.playSound("NextLevel.wav");
            sliding = false;
            transition = 250; 
            getWorld().setPaintOrder(Display.class,Button.class,miniMenu.class,overlay.class,BouncerActor.class,drop.class);
        }
        menu.setLevel(level);
        menu.setBonusing(false);
        preLoad(level);
        buffer = new GreenfootImage(getWorld().getBackground());
        bouncers = getWorld().getObjects(BouncerActor.class);
        drops = getWorld().getObjects(BouncerActor.class);
        for(int i=0;i<drops.size();i++){
            ((BouncerActor)drops.get(i)).freeze();
        }
        drops = getWorld().getObjects(drop.class);
        for(int i=0;i<drops.size();i++){
            ((drop)drops.get(i)).freeze();
        }
        drops = getWorld().getObjects(firework.class);
        for(int i=0;i<drops.size();i++){
            getWorld().removeObject(((firework)drops.get(i)));
        }
        boolean playSound = false;
        for(int i=0;i<bouncers.size();i++){
            BouncerActor bouncerA = ((BouncerActor)bouncers.get(i));
            if(bouncerA.isAway()){
                 playSound = true;   
            }
        }
        if(playSound && level!=0){
            Greenfoot.playSound("Bonus.wav");
        }
    }
    
    //LOADLEVEL****************************************************************************
    //  adds the level objects to the world
    
    public void loadLevel(int n){
        menu.setBonusing(true);
        ((worldness)getWorld()).setTerrainOn();
        getWorld().setPaintOrder(BouncerActor.class,Display.class,Button.class,overlay.class,miniMenu.class,drop.class);
        transitioning = false;
        if(killAll){
            ((worldness)getWorld()).killAll();
        }
        ((worldness)getWorld()).kill();
        getWorld().setBackground(new GreenfootImage(background));
        getImage().clear();
        if(currentLevel == 0){
            menu.clearAlpha();
           getWorld().addObject(menu,250,25);
        }
        
        if(n==1){
            menu.clearAlpha();
            getWorld().addObject(new plate(3),0,0);
            getWorld().addObject(new Cup(),292,405);
            getWorld().addObject(new Pipe(),189,138);
            getWorld().addObject(new Helper(1),0,0);
            menu.setBonus(90000);
        }
        if(n==2){
            getWorld().addObject(new Cup(),221,364);
            getWorld().addObject(new Pipe(),183,179);
            getWorld().addObject(new plate(4),0,0);
            getWorld().addObject(new plate(1),0,0);
            getWorld().addObject(new Helper(2),0,0);
            menu.setBonus(60000);
        }
        if(n==3){
            getWorld().addObject(new Pipe(),267,157);
            getWorld().addObject(new Cup(),165,356);
            getWorld().addObject(new plate(1),0,0);
            getWorld().addObject(new plate(2),0,0);
            getWorld().addObject(new plate(3),0,0);
            getWorld().addObject(new plate(4),0,0);
            getWorld().addObject(new Helper(3),0,0);
            menu.setBonus(130000);
        }
        if(n==4){
            getWorld().addObject(new Pipe(),183,197);
            getWorld().addObject(new Cup(),342,220);
            getWorld().addObject(new plate(3),0,0);
            getWorld().addObject(new plate(1),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new Helper(4),0,0);
            menu.setBonus(80000);
        }
        if(n==5){
            getWorld().addObject(new Pipe(),310,189);
            getWorld().addObject(new Cup(),163,339);
            getWorld().addObject(new cone(),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new Helper(5),0,0);
            menu.setBonus(60000);
        }
        if(n==6){
            getWorld().addObject(new Pipe(Color.blue),113,146);
            getWorld().addObject(new Cup(Color.blue),186,269);
            getWorld().addObject(new Pipe(Color.green),371,149);
            getWorld().addObject(new Cup(Color.green),369,269);
            getWorld().addObject(new Door(47,90,Color.green),185,244);
            getWorld().addObject(new Switch(Color.green,90),341,203);
            getWorld().addObject(new plate(2),0,0);
            getWorld().addObject(new Helper(6),0,0);
            menu.setBonus(50000);
        }
        if(n==7){
            getWorld().addObject(new Pipe(),152,117);
            getWorld().addObject(new Cup(),308,402);
            getWorld().addObject(new plate(4),0,0);
            getWorld().addObject(new plate(0),0,0);
            getWorld().addObject(new Switch(Color.blue,90),128,266);
            getWorld().addObject(new Switch(Color.green,-90,1),317,217);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new Door(38,0,Color.blue),180,247);
            getWorld().addObject(new Door(41,0,Color.green),265,343);
            getWorld().addObject(new Helper(7),0,0);
            menu.setBonus(120000);
        }
        if(n==8){
            getWorld().addObject(new Pipe(Color.blue),92,151);
            getWorld().addObject(new Pipe(Color.red),130,151);
            getWorld().addObject(new Cup(Color.blue),147,441);
            getWorld().addObject(new Cup(Color.red),307,389);
            getWorld().addObject(new Hoop(Color.blue,90),160,177);
            getWorld().addObject(new Hoop(Color.red,90),166,390);
            getWorld().addObject(new plate(1),0,0);
            getWorld().addObject(new plate(2),0,0);
            getWorld().addObject(new plate(3),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new cone(),0,0);
            getWorld().addObject(new Door(23,90,Color.red),266,194);
            getWorld().addObject(new Door(44,90,Color.blue),195,321);
            menu.setBonus(140000);
        }
        if(n==9){
            getWorld().addObject(new Pipe(Color.blue),193,205);
            getWorld().addObject(new Pipe(Color.red),295,169);
            getWorld().addObject(new Cup(Color.blue),251,363);
            getWorld().addObject(new Cup(Color.red),290,363);
            getWorld().addObject(new Door(55,-45,Color.red),296,216);
            getWorld().addObject(new Door(22,90,Color.blue),140,297);
            getWorld().addObject(new Switch(Color.blue,-90),320,279);
            getWorld().addObject(new Switch(Color.red,-90,1),267,331);
            getWorld().addObject(new plate(1),0,0);
            getWorld().addObject(new plate(3),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new Helper(8),0,0);
            menu.setBonus(80000);
        }
        if(n==10){
            getWorld().addObject(new Pipe(Color.blue),441,434);
            getWorld().addObject(new Cup(Color.blue,180),347,73);
            getWorld().addObject(new plate(4),0,0);
            getWorld().addObject(new cannon(),0,0);
            getWorld().addObject(new cannon(),0,0);
            getWorld().addObject(new cannon(),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new spring(),0,0);
            menu.setBonus(100000);
        }
        if(n==11){
            getWorld().addObject(new Pipe(Color.blue),126,91);
            getWorld().addObject(new Pipe(Color.red),322,91);
            getWorld().addObject(new Cup(Color.blue,90),71,447);
            getWorld().addObject(new Cup(Color.red,90),233,462);
            getWorld().addObject(new Switch(Color.blue,-180),361,198);
            getWorld().addObject(new Switch(Color.red,0,1),243,423);
            getWorld().addObject(new Switch(Color.blue,-90),165,259);
            getWorld().addObject(new Switch(Color.red,0,1),177,116);
            getWorld().addObject(new Door(33,0,Color.blue),101,253);
            getWorld().addObject(new Door(31,90,Color.red),234,368);
            getWorld().addObject(new Door(82,-45,Color.red),305,118);
            getWorld().addObject(new plate(4),0,0);
            getWorld().addObject(new plate(3),0,0);
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new cannon(),0,0);
            menu.setBonus(100000);
        }
        if(n==12){
            getWorld().addObject(new Pipe(),447,68);
            getWorld().addObject(new Cup(),262,270);
            getWorld().addObject(new Door(55,90,Color.red),319,209);
            getWorld().addObject(new Door(42,90,Color.red),261,209);
            getWorld().addObject(new Door(55,90,Color.green),204,209);
            getWorld().addObject(new Door(55,90,Color.green),383,209);
            getWorld().addObject(new Door(55,90,Color.blue),447,209);
            getWorld().addObject(new Door(55,90,Color.blue),140,209);
            getWorld().addObject(new Hoop(Color.red,90),261,331);
            getWorld().addObject(new Hoop(Color.green,90),261,387);
            getWorld().addObject(new Hoop(Color.blue,90),261,438);
            
            getWorld().addObject(new spring(),0,0);
            getWorld().addObject(new cannon(),0,0);
            getWorld().addObject(new cannon(),0,0);
            getWorld().addObject(new cannon(),0,0);
            getWorld().addObject(new plate(4),0,0);
            getWorld().addObject(new plate(3),0,0);
            getWorld().addObject(new plate(2),0,0);
            menu.setBonus(140000);
        }
        ((worldness)getWorld()).setFill();
        killAll = false;
        
        if(n==0){
            ((worldness)getWorld()).setInMenu(true);
            getWorld().addObject(new Button(1),261,360);
            getWorld().addObject(new Button(2),257,440);
            level = 0;
            sliding = false;
            transition = 0;
            killAll = true;
        }
        
        
    }
    
    //PRELOAD****************************************************************************
    //  loads the background of the next level for the transition
    
    public void preLoad(int n){
        if(n!=0){
            buffer = new GreenfootImage("Level"+level+".bmp");
            Color temp;
            ((worldness)getWorld()).getTerrainBuffer().setColor(Color.white);
            ((worldness)getWorld()).getTerrainBuffer().fill();
            ((worldness)getWorld()).setTerrainOff();
            for(int i=0;i<500;i++){
                for(int j=0;j<450;j++){
                    temp = buffer.getColorAt(i,j);
                    if(!temp.equals(Color.white)){
                        background.setColorAt(i,j+50,temp);
                        ((worldness)getWorld()).getTerrainBuffer().setColorAt(i,j+50,Color.black);
                    }
                }
            }
        }else{
            background = new GreenfootImage("TitleScreen.bmp");
            ((worldness)getWorld()).setTerrainBuffer(new GreenfootImage("TitleMask.gif"));
        }
    }
    
    //GETLEVEL****************************************************************************
    //  returns the current level to be transitioned into
    
    public int getLevel(){
        return level;
    }
    
    //SETNEXTLEVEL****************************************************************************
    //  sets the next level to transition in
    
    public void setNextLevel(int n){
        level = n;
    }
    
    //NEXTLEVEL****************************************************************************
    //  increments the level counter
    
    public void nextLevel(){
        level++;
    }
    
    //GETCURRENTLEVEL****************************************************************************
    //  returns the current level number
    
    public int getCurrentLevel(){
        return currentLevel;
    }
    
    //LOADCODE****************************************************************************
    //  loads a level based on user input codes
    
    public void loadCode(String text){
        for(int i=0;i<codes.length;i++){
            if(codes[i].equals(text)){
                level = i;
                start();
            }
        }
    }
    
    //SETKILL****************************************************************************
    //  sets whether or not all objects will be cleared durring transition
    
    public void setKill(boolean k){
        killAll = k;
    }
    
    //GETSCORE****************************************************************************
    //  returns the current score
    
    public int getScore(){
        return menu.getScore();
    }
    

}
